local locale, _, T = GetLocale(), ...

-- See http://wow.curseforge.com/addons/spade/localization/
local L = {
	["tool:80513"] = "Requires [Vintage Bug Sprayer] to disinfest",
	["use:80513"] = "Spray plant",
	["tool:79104"] = "Requires [Rusty Watering Can] to water",
	["use:79104"] = "Water plant",
	["tool:89880"] = "Requires [Dented Shovel] to remove",
	["use:89880"] = "Remove plant",
	["use:89815"] = "Till row"
}

if locale == "frFR" then
	L["Plant a seed"] = "Planter une graine"
	L["Requires %s to select seeds"] = "Requiert %s pour choisir des graines"
	L["tool:79104"] = "Requiert [Arrosoir rouillé] pour arroser"
	L["tool:80513"] = "Requiert [Vaporisateur à insectes de collection] pour désinfester"
	L["tool:89880"] = "Requiert [Pelle abîmée] pour arracher"
	L["use:79104"] = "Arroser la plante"
	L["use:80513"] = "Vaporiser la plante"
	L["use:89880"] = "Arracher la plante"

elseif locale == "koKR" then
	L["Plant a seed"] = "씨 뿌리기"
	L["Requires %s to select seeds"] = "씨앗을 선택해야 합니다."
	L["tool:79104"] = "녹슨 물뿌리개가 필요합니다."
	L["tool:80513"] = "오래된 살충제가 필요합니다."
	L["tool:89880"] = "찌그러진 삽이 필요합니다."
	L["use:79104"] = "녹슨 물뿌리개"
	L["use:80513"] = "오래된 살충제"
	L["use:89815"] = "최고급 쟁기"
	L["use:89880"] = "찌그러진 삽"

elseif locale == "ruRU" then
	L["Plant a seed"] = "Посадить семена"
	L["Requires %s to select seeds"] = "Требует %s для выбора семян"
	L["tool:79104"] = "Требует [Ржавая лейка] для полива"
	L["tool:80513"] = "Требует [Старый опрыскиватель] для опрыскивания"
	L["tool:89880"] = "Требует [Зазубренная лопата] чтобы выкопать"
	L["use:79104"] = "Полить растение"
	L["use:80513"] = "Опрыскать растение"
	L["use:89880"] = "Убрать растение"

elseif locale == "esES" or locale == "esMX" then
	L["Plant a seed"] = "Planta una semilla"
	L["Requires %s to select seeds"] = "Requiere %s para seleccionar las semillas"
	L["tool:79104"] = "Requiere [Regadera oxidada] para regar la planta"
	L["tool:80513"] = "Requiere [Pulverizador de insectos infalible] para pulverizar los insectos"
	L["tool:89880"] = "Requiere [Pala abollada] para destruir la planta"
	L["use:79104"] = "Riegue la planta"
	L["use:80513"] = "Pulverice los insectos"
	L["use:89880"] = "Destruye la planta"

elseif locale == "deDE" then
	L["Plant a seed"] = "Säen"
	L["Requires %s to select seeds"] = "Du brauchst %s um Saatgut auszuwählen"
	L["tool:79104"] = "Benötigt die [Rostige Gießkanne] zum Gießen"
	L["tool:80513"] = "Benötigt [Altmodisches Insektenvernichtungsmittel] zum Desinfizieren"
	L["tool:89880"] = "Benötigt die [Verbeulte Schaufel] zum Entfernen"
	L["use:79104"] = "Gießen"
	L["use:80513"] = "Desinfizieren"
	L["use:89815"] = "Beet umgraben"
	L["use:89880"] = "Ausgraben"

elseif locale == "zhTW" then
	L["Plant a seed"] = "播種"
	L["Requires %s to select seeds"] = "需要%s以選擇種子"
	L["tool:79104"] = "需要[生鏽的灑水壺]來灌溉"
	L["tool:80513"] = "需要[古董殺蟲噴霧器]來除蟲"
	L["tool:89880"] = "需要[有凹陷的鏟子]來移除"

elseif locale == "zhCN" then
	L["Plant a seed"] = "播种"
	L["Requires %s to select seeds"] = "需要%s选择种子"
	L["tool:79104"] = "需要[生锈的洒水壶]灌溉"
	L["tool:80513"] = "需要[优质杀虫剂]除虫"
	L["tool:89880"] = "需要[凹陷铲子]移除"
	L["use:79104"] = "灌溉农作物"
	L["use:80513"] = "喷洒农作物"
	L["use:89880"] = "移除农作物"

elseif locale == "ptBR" then
	L["Announce harvest on log in"] = "Anunciar colheita ao logar"
	L["Bind OPie rings"] = "Vincular teclas aos anéis do OPie"
	L["Clear current farm"] = "Limpar fazenda atual"
	L["%d |4plant:plants; ready for harvest on alts: [View Farms]."] = "%d |4plant:plants; prontas para a colheita em alts: [Ver Fazendas]."
	L["%d |4plant:plants; ready for harvest: [View Farms]."] = "%d |4plant:plants; prontas para a colheita: [Ver Fazendas]."
	L["Default (prefer seeds)"] = "Padrão (preferir sementes)"
	L["For farming at the Sunsong Ranch."] = "Praticar a lavoura na Fazenda Sol Cantante."
	L["Inverted (prefer bags)"] = "Invertido (preferir sacos)"
	L["None"] = "Nenhum"
	L["Only seed bags"] = "Apenas sacos de sementes"
	L["Only seeds"] = "Apenas sementes"
	L["Plant a seed"] = "Plantar uma semente"
	L["Requires %s to select seeds"] = "Requer %s para selecionar sementes"
	L["Sunsong Ranch Plants"] = "Plantas da Fazenda Sol Cantante"
	L["tool:79104"] = "Requer [Regador Enferrujado] para regar"
	L["tool:80513"] = "Requer [Pulverizador Antigo] para desinfestar"
	L["tool:89880"] = "Requer [Pá Dentada] para remover"
	L["use:79104"] = "Regar planta"
	L["use:80513"] = "Borrifar na planta"
	L["use:89815"] = "Arar em linha reta"
	L["use:89880"] = "Remover planta"
	L["Use a seed bag"] = "Usar um saco de sementes"

end

T.L = setmetatable(L, {__index=function(_, i) return i end, __call=function(s,i) return s[i] end})