local spells, bagSpells, trackerFrame, _, T = {}, {}, CreateFrame("FRAME"), ...
local nspells = {}
local CLEAR_PLANT_SPELLID = 131187
local JOGU_NPCID = 58710

local NINE = select(4,GetBuildInfo()) > 9e4

local function UnitNPCID(unit)
	local guid = UnitGUID(unit)
	return guid and tonumber((guid:match("^Creature%-.-(%d+)%-%x*$")))
end

for i, n, b, p, h in ("85264 66172 0 123892 130140;85216 65916 139978 123774 129675 129676 129687 129705 129673 129674;74840 58566 116356 111102 123355 111123;74847 66109 131094 129976 130026 130025;74841 63153 123362 123361 123353 123356;85217 65986 139981 123775 129796;74842 63181 123486 123485 123451 123445;85219 66152 0 123777 130109;74849 63246 123566 123565 123549 123548;89202 66013 139986 129628 129843;74844 63224 123537 123535 123524 123522;74843 63161 123389 123388 123375 123380;85215 65965 139977 123773 129757;89233 66040 139975 129863 129887;85265 66189 0 130170 130168;74848 66124 131095 129978 130042 130043;91806 67482 0 133036 133106;74850 63261 123567 123568 123571 123570;89197 66003 139983 129623 129814;85266 66171 0 123894 123516;74846 66081 131093 129974 129984 129983"):gmatch("(%d+) (%d+) (%d+) (%d+) ([^;]*)") do
	i, b, n, p = tonumber(i), tonumber(b), tonumber(n), tonumber(p)
	spells[p], nspells[n], bagSpells[b] = i, i, i
	for h in h:gmatch("%d+") do
		spells[tonumber(h)] = -i
	end
end

local function GetHourDates()
	local ds = C_DateAndTime.GetCurrentCalendarTime()
	local m, d, y = ds.month, ds.monthDay, ds.year
	C_Calendar.SetAbsMonth(m, y) -- Sorry.
	local t, _, _, lastDay = (y * 100 + m) * 100 + d, C_Calendar.GetMonthInfo(0)
	d = (d == lastDay and 1 or (d+1))
	m, y = d > 1 and m or ((m % 12) + 1), y + (d == 1 and m == 12 and 1 or 0)
	return GetGameTime(), t, (y * 100 + m) * 100 + d
end
function T.GetFarmSize()
	local IsQuestFlaggedCompleted = C_QuestLog.IsQuestFlaggedCompleted
	return IsQuestFlaggedCompleted(30529) and 16 or
		IsQuestFlaggedCompleted(30524) and 12 or
		IsQuestFlaggedCompleted(30516) and 8 or
		IsQuestFlaggedCompleted(30257) and 4 or 0
end
local function crt(t, a, ...)
	if a then
		if type(t[a]) ~= "table" then t[a] = {} end
		return crt(t[a], ...)
	end
	return t
end

local function isPastReset(eH, eT, eN, rH)
	local t, nH, nT = eH < (rH or 3) and eT or eN, GetHourDates()
	return t < nT or (t == nT and nH >= (rH or 3))
end
local function coalesce(rt, ct)
	ct = ct or crt(rt, UnitName("player"))
	if ct.leH and ct.leT and ct.leN and type(ct.future) == "table" and next(ct.future) then
		if isPastReset(ct.leH, ct.leT, ct.leN, rt._reset) then
			for k,v in pairs(ct.future) do
				ct[k], ct.future[k], ct[k] = (ct[k] or 0) + v
			end
			ct.leH, ct.leT, ct.leN = nil
		end
	end
	if type(ct) == "table" and ct[85223] then
		ct[85216], ct[85223] = (ct[85216] or 0) + ct[85223]
	end
	if type(ct) == "table" and type(ct.future) == "table" and ct.future[85223] then
		ct.future[85216], ct.future[85223] = (ct.future[85216] or 0) + ct.future[85223]	
	end
	return ct
end


local function showSpadeUI(updateOnly)
	local rt = crt(_G, "SpadeData", GetRealmName())
	if not (rt._gossip and rt._geH and rt._geT and rt._geN) or isPastReset(rt._geH, rt._geT, rt._geN, rt._reset) then
		rt._gossip, rt._geH, rt._geT, rt._geN = nil
	end
	for _,v in pairs(rt) do if type(v) == "table" then coalesce(rt, v) end end
	T.showSpadeUI(updateOnly, rt._gossip, rt)
end
T.updateAndShowSpadeUI = showSpadeUI

local function registerPlant(ct, iid, cnt)
	local ft, fs = crt(ct, "future"), T.GetFarmSize()
	ft[iid], ct.sz, ct.leH, ct.leT, ct.leN = (ft[iid] or 0) + cnt, fs ~= 0 and fs or ct.sz, GetHourDates()
end

function T.HintFarmReset(secDelta)
	local dm, h, m = math.floor(secDelta/60), GetGameTime()
	m, h = m + (dm % 60), h + math.floor(dm / 60)
	h = (h + (m > 30 and 1 or 0)) % 24
	crt(_G, "SpadeData", GetRealmName())._reset = h
end
function T.InitTracker()
	local f, captureGossip, bagTime, bagItem, bagCount = trackerFrame, false
	f:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	f:RegisterEvent("UNIT_SPELLCAST_SENT")
	f:RegisterEvent("GOSSIP_CLOSED")
	f:RegisterEvent("GOSSIP_SHOW")
	local function bagNextFrame(self)
		self:SetScript("OnUpdate", nil)
		self:UnregisterEvent("CRITERIA_UPDATE")
		if bagItem and bagCount > 0 then
			registerPlant(coalesce(crt(_G, "SpadeData", GetRealmName())), bagItem, bagCount)
			showSpadeUI(true)
		end
		bagTime, bagItem, bagCount = nil
	end
	f:SetScript("OnEvent", function(self, event, u, cg, sid, ex)
		local stn = nil
		if event == "UNIT_SPELLCAST_SENT" then
			stn, cg, sid = cg, sid, ex
		end
		if u == "player" then
			if event == "UNIT_SPELLCAST_SUCCEEDED" and spells[sid] or (sid == CLEAR_PLANT_SPELLID and self.removeID) then
				local iid, ct = spells[sid], coalesce(crt(_G, "SpadeData", GetRealmName()))
				if sid == CLEAR_PLANT_SPELLID and self.removeID then
					local ft = crt(ct, "future")
					ft[self.removeID], self.removeID = (ft[self.removeID] or 0) > 1 and (ft[self.removeID] - 1) or nil
				elseif iid < 0 then
					if (ct[-iid] or 0) <= 0 and type(ct.future) == "table" then
						ct = ct.future
					end
					ct[-iid] = (ct[-iid] or 0) > 1 and (ct[-iid] - 1) or nil
				else
					registerPlant(ct, iid, 1)
				end
				showSpadeUI(true)
			elseif event == "UNIT_SPELLCAST_SUCCEEDED" and sid ~= 0 and bagSpells[sid] then
				self:RegisterEvent("CRITERIA_UPDATE")
				bagTime, bagItem, bagCount = GetTime(), bagSpells[sid], 0
			elseif event == "UNIT_SPELLCAST_SENT" and sid == CLEAR_PLANT_SPELLID then
				local tg = UnitNPCID(UnitName("target") == stn and "target" or (UnitName("mouseover") == stn and "mouseover" or "")) or ""
				self.removeID = nspells[tg]
			end
		elseif event == "CRITERIA_UPDATE" and bagTime then
			if GetTime() - bagTime <= 0.5 and bagCount < 4 then
				bagCount = bagCount + 1
				self:SetScript("OnUpdate", bagNextFrame)
			else
				self:UnregisterEvent("CRITERIA_UPDATE")
				bagTime, bagItem, bagCount = nil
			end
		elseif event == "GOSSIP_CLOSED" then
			captureGossip = false
		elseif event == "GOSSIP_SHOW" and captureGossip and UnitNPCID("npc") == JOGU_NPCID then
			local rt = crt(_G, "SpadeData", GetRealmName())
			captureGossip, rt._gossip, rt._geH, rt._geT, rt._geN = false, (NINE and C_GossipInfo.GetText or GetGossipText)(), GetHourDates()
			showSpadeUI(true)
		end
	end)
	hooksecurefunc(NINE and C_GossipInfo or _G, NINE and "SelectOption" or "SelectGossipOption", function()
		captureGossip = UnitNPCID("npc") == JOGU_NPCID
	end)
end
function T.TrackerOnLogin()
	local rt, me, c, mc = type(SpadeData) == "table" and type(SpadeData[GetRealmName()]) == "table" and SpadeData[GetRealmName()], UnitName("player"), 0, 0
	if not rt then return end
	for k,v in pairs(rt) do
		if type(v) == "table" then
			coalesce(rt, v)
			for i,v in pairs(v) do
				if type(i) == "number" and type(v) == "number" then
					c, mc = c + v, mc + (k == me and v or 0)
				end
			end
		end
	end

	T.AnnounceHarvest(mc, c)
end
local function hasPlants(t)
	for k,v in pairs(t) do
		if type(k) == "number" and type(v) == "number" then
			return true
		end
	end
end
function T.PlayerHasPlants()
	local t, t2 = SpadeData
	t = type(t) == "table" and t[GetRealmName()]
	t = type(t) == "table" and t[UnitName("player")]
	t2 = type(t) == "table" and t.future
	return type(t) == "table" and (hasPlants(t) or (type(t2) == "table" and hasPlants(t2))) or false
end
function T.GetPlayerFarm()
	return crt(_G, "SpadeData", GetRealmName(), UnitName("player"))
end